## ros-foxy-tile-map 2.2.1

=== CMakeLists.txt ===
### SET CMAKE POLICIES ###
cmake_minimum_required(VERSION 3.10...3.17)

if(${CMAKE_VERSION} VERSION_LESS 3.12)
    cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()

if (NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(${CMAKE_VERSION} VERSION_EQUAL "3.11.0" OR ${CMAKE_VERSION} VERSION_GREATER "3.11.0")
  cmake_policy(SET CMP0072 NEW)
endif()

if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()
### END CMAKE POLICIES ###

project(tile_map
  LANGUAGES CXX)

# ROS packages
find_package(ament_cmake REQUIRED)
find_package(mapviz REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(swri_math_util REQUIRED)
find_package(swri_transform_util REQUIRED)
find_package(tf2 REQUIRED)

# Qt 5
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5OpenGL REQUIRED)
find_package(Qt5Widgets REQUIRED)
# Still useful?
# add_definitions(-DWFlags=WindowFlags)

### OpenGL ###
find_package(OpenGL REQUIRED)

### GLEW ###
find_package(GLEW REQUIRED)

### PkgConfig ###
find_package(PkgConfig REQUIRED)

### yaml-cpp ###
pkg_check_modules(YamlCpp yaml-cpp)

### Use PkgConfig to find jsoncpp ###
pkg_check_modules(JSONCPP REQUIRED jsoncpp)

# Fix conflict between Boost signals used by tf and QT signals used by mapviz
add_definitions(-DQT_NO_KEYWORDS)

# Need to include the current dir to include the results of building Qt UI files
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(TILE_SRC_FILES
  src/image_cache.cpp
  src/texture_cache.cpp
  src/bing_source.cpp
  src/tile_source.cpp
  src/wmts_source.cpp
  src/${PROJECT_NAME}_view.cpp
)
set(QT_HEADERS
  include/${PROJECT_NAME}/image_cache.h
  include/${PROJECT_NAME}/tile_source.h
  include/${PROJECT_NAME}/wmts_source.h
  include/${PROJECT_NAME}/bing_source.h
)
qt5_wrap_cpp(TILE_SRC_FILES ${QT_HEADERS})
add_library(${PROJECT_NAME} ${TILE_SRC_FILES})
target_include_directories(${PROJECT_NAME}
  PUBLIC
    include)
target_include_directories(${PROJECT_NAME} SYSTEM
  PUBLIC
    GLEW::GLEW
    ${JSONCPP_INCLUDE_DIRS}
    ${YamlCpp_INCLUDE_DIRS})
ament_target_dependencies(${PROJECT_NAME}
  ament_cmake
  mapviz
  pluginlib
  rclcpp
  swri_math_util
  swri_transform_util
  tf2
)
target_link_libraries(${PROJECT_NAME}
  ${GLU_LIBRARY}
  ${JSONCPP_LIBRARIES}
  ${YamlCpp_LIBRARIES}
  Qt5::Network
  Qt5::Core
  Qt5::Gui
  Qt5::OpenGL
  Qt5::Widgets
)

set(PLUGIN_SRC_FILES
  src/${PROJECT_NAME}_plugin.cpp)
set(PLUGIN_UI_FILES
  src/${PROJECT_NAME}_config.ui)

qt5_wrap_ui(PLUGIN_SRC_FILES ${PLUGIN_UI_FILES})
qt5_wrap_cpp(PLUGIN_SRC_FILES include/${PROJECT_NAME}/${PROJECT_NAME}_plugin.h)

add_library(${PROJECT_NAME}_plugin SHARED ${PLUGIN_SRC_FILES})
target_compile_definitions(${PROJECT_NAME}_plugin PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(${PROJECT_NAME}_plugin ${PROJECT_NAME})

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
  FILES_MATCHING PATTERN "*.h"
)

install(TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_plugin
  RUNTIME DESTINATION lib/${PROJECT_NAME}
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

pluginlib_export_plugin_description_file(mapviz mapviz_plugins.xml)

ament_export_dependencies(${RUNTIME_DEPS}
  Qt5::Network
  Qt5::Core
  Qt5::Gui
  Qt5::OpenGL
  Qt5::Widgets
)
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_package()

=== debian/changelog ===
ros-foxy-tile-map (2.2.1-1focal) focal; urgency=high

  * Updating maintainers list (#778 <https://github.com/swri-robotics/mapviz/issues/778>)
  * Contributors: David Anthony

 -- Southwest Research Institute <swri-robotics@swri.org>  Tue, 30 May 2023 05:00:00 -0000

ros-foxy-tile-map (2.1.0-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Thu, 22 Oct 2020 05:00:00 -0000

ros-foxy-tile-map (2.0.0-1focal) focal; urgency=high

  * Port mapviz to ROS 2 (#672 <https://github.com/swri-robotics/mapviz/issues/672>)
  * Remove OpenGL warning (#667 <https://github.com/swri-robotics/mapviz/issues/667>)
  * Contributors: Daniel D'Souza, P. J. Reed, Jacob Hassold, Kevin Nickels, Roger Strain, Matthew Bries

 -- P. J. Reed <preed@swri.org>  Wed, 13 May 2020 05:00:00 -0000

ros-foxy-tile-map (1.2.0-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Wed, 04 Sep 2019 05:00:00 -0000

ros-foxy-tile-map (1.1.1-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Fri, 17 May 2019 05:00:00 -0000

ros-foxy-tile-map (1.1.0-1focal) focal; urgency=high

  * Fix non-Bing sources (#615 <https://github.com/swri-robotics/mapviz/issues/615>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Wed, 20 Feb 2019 06:00:00 -0000

ros-foxy-tile-map (1.0.1-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Fri, 25 Jan 2019 06:00:00 -0000

ros-foxy-tile-map (1.0.0-1focal) focal; urgency=high

  * Sharing tf_manager_ between main app and plugins (#555 <https://github.com/swri-robotics/mapviz/issues/555>)
  * Fix issue with loading Bing map tiles (#599 <https://github.com/swri-robotics/mapviz/issues/599>)
  * Contributors: Davide Faconti, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Wed, 23 Jan 2019 06:00:00 -0000

ros-foxy-tile-map (0.3.0-1focal) focal; urgency=high

  * Merge all -devel branches into a single master branch
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Fri, 16 Nov 2018 06:00:00 -0000

ros-foxy-tile-map (0.2.6-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Tue, 31 Jul 2018 05:00:00 -0000

ros-foxy-tile-map (0.2.5-1focal) focal; urgency=high

  * Bug fix in TileMap. GenTexture was invoked over and over again (#559 <https://github.com/swri-robotics/mapviz/issues/559>)
  * Improve tile loading prioritization.
  * Glew warning fixed (#539 <https://github.com/swri-robotics/mapviz/issues/539>)
  * update to use non deprecated pluginlib macro
  * Contributors: Davide Faconti, Marc Alban, Mikael Arguedas, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Thu, 12 Apr 2018 05:00:00 -0000

ros-foxy-tile-map (0.2.4-1focal) focal; urgency=high

  * add include for boost::algorithm::trim_copy to fix tile_map_plugin.cpp:408:31: error: ‘trim_copy’ is not a member of ‘boost’ (#497 <https://github.com/swri-robotics/mapviz/issues/497>)
  * Contributors: Austin Deric

 -- P. J. Reed <preed@swri.org>  Fri, 11 Aug 2017 05:00:00 -0000

ros-foxy-tile-map (0.2.3-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Sat, 10 Dec 2016 06:00:00 -0000

ros-foxy-tile-map (0.2.2-1focal) focal; urgency=high



 -- P. J. Reed <preed@swri.org>  Wed, 07 Dec 2016 06:00:00 -0000

ros-foxy-tile-map (0.2.1-1focal) focal; urgency=high

  * Rewrite tile_map loading to be more reliable
    This changes how the tile_map plugin handles making network requires for tiles.
    It will now:
    - Use thread conditions to prompt loading rather than spinning
    - Prioritize loading tiles in the visible area
    - Retry a failed network request up to 5 times
    - Not discard tile requests if there are more than 100 in the queue
    This changes should significantly reduce (if not completely eliminate) the
    number of tiles that fail to load and hopefully make tiles within the visible
    area appear faster when there are many in the queue.
    Fixes #342 <https://github.com/swri-robotics/mapviz/issues/342> and #421 <https://github.com/swri-robotics/mapviz/issues/421>.
  * Adding support for Bing Maps (#409 <https://github.com/swri-robotics/mapviz/issues/409>)
    This makes a number of changes in the tile_map plugin in order to support
    different types of tile servers, including Bing Maps.  Notable changes include:
    - TileSource is now an abstract class
    - WMTS server-specific behavior has been moved into a new WmtsSource class
    - BingSource provides support for obtaining tiles from Bing Maps
    - The UI for specifying server URLs has changed
    - Prefix and coordinate order are no longer separate fields
    - In URLs for WMTS sources, the variables {level}, {x}, and {y} will be substituted with appropriate values when tiles are requested
    - Rather than generating hashes for image tiles based on their URLs, hashes are now generated by the TileSource implementations in order to support sources that can pull tiles from multiple servers
    - Idle performance has been improved by removing redundant recalculations of the map view
    - Added a dependency on libjsoncpp
    Resolves #227 <https://github.com/swri-robotics/mapviz/issues/227>
    Conflicts:
    tile_map/CMakeLists.txt
    tile_map/package.xml
  * Giving tile_map an interface overhaul
    MapQuest has turned off their public API for map tiles, so this plugin needed some work.  I have:
    - Removed the MapQuest sources
    - Made the interface for adding new sources more powerful
    - Overhauled how sources are saved and loaded under the hood
    - Added a button to reset the current tile cache
    Resolves #402 <https://github.com/swri-robotics/mapviz/issues/402>
    Conflicts:
    tile_map/CMakeLists.txt
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Sun, 23 Oct 2016 05:00:00 -0000

ros-foxy-tile-map (0.2.0-1focal) focal; urgency=high

  * Update tile_map to Qt5.
  * Contributors: Ed Venator

 -- P. J. Reed <preed@swri.org>  Thu, 23 Jun 2016 05:00:00 -0000

ros-foxy-tile-map (0.1.3-1focal) focal; urgency=high

  * Fix typo in tile map view size comparison.


=== debian/control ===
Source: ros-foxy-tile-map
Section: misc
Priority: optional
Maintainer: Southwest Research Institute <swri-robotics@swri.org>
Build-Depends: debhelper (>= 9.0.0), libglew-dev, libjsoncpp-dev, libqt5core5a, libqt5opengl5-dev, libyaml-cpp-dev, qt5-qmake, ros-foxy-ament-cmake, ros-foxy-mapviz, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-swri-math-util, ros-foxy-swri-transform-util, ros-foxy-tf2, ros-foxy-ros-workspace
Homepage: https://github.com/swri-robotics/mapviz
Standards-Version: 3.9.2

Package: ros-foxy-tile-map
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libglew-dev, libjsoncpp1, libqt5core5a, libqt5opengl5, libyaml-cpp-dev, ros-foxy-mapviz, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-swri-math-util, ros-foxy-swri-transform-util, ros-foxy-tf2, ros-foxy-ros-workspace
Description: Tile map provides a slippy map style interface for visualizing OpenStreetMap and GoogleMap tiles.
 A mapviz visualization plug-in is also implemented

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-tile-map//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
